<?php

declare(strict_types=1);

namespace Drupal\error_page_test\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Testing controller.
 */
class ErrorPageTestController extends ControllerBase {

  /**
   * Simulates an exception.
   */
  public function exception() {
    throw new \Exception('donuts');
  }

  /**
   * Simulates a fatal error.
   */
  public function fatalError() {
    // @codingStandardsIgnoreLine
    /** @phpstan-ignore method.notFound */
    $this->functionDoesNotExist();
  }

  /**
   * Simulates a user error.
   */
  public function userError(): array {
    trigger_error('donuts', E_USER_ERROR);
    return ['#markup' => 'whatever'];
  }

  /**
   * Simulates a PHP notice error.
   */
  public function notice(): array {
    // @codingStandardsIgnoreLine
    /** @phpstan-ignore variable.undefined */
    return ['#markup' => $not_initialized_variable];
  }

}
